# Group

## Group class

class tango.Group(name)

  Bases: `object`

  A Tango Group represents a hierarchy of tango devices. The hierarchy may have more than one level. The main goal is to group devices with same attribute(s)/command(s) to be able to do parallel requests.

  add(self, device, timeout_ms=-1) → None
  add(self, device_list, timeout_ms=-1) → None
  add(self, subgroup, timeout_ms=-1) → None
    Throws:

      TypeError, ArgumentError

    Attaches any device which name matches one of the specified patterns.

    This method first asks the Tango database the list of device names matching one the patterns. Devices are then attached to the `group` in the order in which they are returned by the database.

    Any device already present in the hierarchy (i.e. a device belonging to the `group` or to one of its subgroups), is silently ignored but its client side timeout is set to timeout_ms milliseconds if timeout_ms is different from -1.

    Parameters:
      device:

        (str)a simple device name or a device name pattern (e.g. domain_*/ family/member_*),

      device_list:

        (sequence<`str`>) a sequence of these of a simple device names or a device name patterns (e.g. domain_*/ family/member_*),

      subgroup:

        (`Group`) a Group to be attached as subgroup.

      timeout_ms:

        (`int`) If timeout_ms is different from -1, the client side timeouts of all devices matching the specified patterns are set to timeout_ms milliseconds.

    Return:

      None

    Throws:

      TypeError, ArgumentError

  command_inout(self, cmd_name, forward=True) → sequence<GroupCmdReply>
  command_inout(self, cmd_name, param, forward=True) → sequence<GroupCmdReply>
  command_inout(self, cmd_name, param_list, forward=True) → sequence<GroupCmdReply>
    Just a shortcut to do:

      self.command_inout_reply(self.command_inout_asynch(…))

    Parameters:
      cmd_name:

        (`str`) Command name

      param:

        (`any`) parameter value

      param_list:

        (`tango.DeviceDataList`) sequence of parameters. When given, it’s length must match the group size.

      forward:

        (`bool`) If it is set to true (the default) request is forwarded to subgroups. Otherwise, it is only applied to the local set of devices.

    Return:

      (sequence<`GroupCmdReply`>)

  command_inout_reply(self: tango._tango.__Group, req_id: SupportsInt, timeout_ms: SupportsInt = 0) → tango._tango.GroupCmdReplyList

    command_inout_reply (self, req_id, timeout_ms=0) -> sequence<`GroupCmdReply`>

    Returns the results of an asynchronous command.

    Parameters:
      req_id:

        (`int`) Is a request identifier previously returned by one of the command_inout_asynch methods

      timeout_ms:

        (`int`) For each device in the hierarchy, if the command result is not yet available, command_inout_reply wait timeout_ms milliseconds before throwing an exception. This exception will be part of the global reply. If timeout_ms is set to 0, command_inout_reply waits “indefinitely”.

    Return:

      (sequence<`GroupCmdReply`>)

    Throws:

  contains(self: tango._tango.__Group, pattern: str, forward: bool = True) → bool

    contains (self, pattern, forward=True) -> `bool`

    Parameters:
      pattern:

        (`str`) The pattern can be a fully qualified or simple group name, a device name or a device name pattern.

      forward:

        (`bool`) If fwd is set to true (the default), the remove request is also forwarded to subgroups. Otherwise, it is only applied to the local set of elements.

    Return:

      (`bool`) Returns true if the hierarchy contains groups and/or devices which name matches the specified pattern. Returns false otherwise.

    Throws:

  disable(*args, **kwargs)

    Overloaded function.

    1. disable(self: tango._tango.__Group) -> None

    2. disable(self: tango._tango.__Group, dev_name: str, forward: bool = True) -> None

    disable (self, dev_name, forward=True) -> `None`

    Disables group element. The element will be excluded from all group operations.

    Parameters:

      - dev_name (str) – device_name name of the element, can contain wildcards (*). If more than one device matches the pattern, only the first one will be disabled.

      - forward (bool) – flag to perform recursive search for the element in all sub-groups

  enable(*args, **kwargs)

    Overloaded function.

    1. enable(self: tango._tango.__Group) -> None

    2. enable(self: tango._tango.__Group, dev_name: str, forward: bool = True) -> None

    enable (self, dev_name, forward=True) -> `None`

    Enables group element. The element will participate in all group operations.

    Parameters:

      - dev_name (str) – device_name name of the element, can contain wildcards (*). If more than one device matches the pattern, only the first one will be enabled.

      - forward (bool) – flag to perform recursive search for the element in all sub-groups

  get_device_list(self: tango._tango.__Group, forward: bool = True) → tango._tango.StdStringVector

    get_device_list (self, forward=True) -> sequence<`str`>

    Considering the following hierarchy:

        g2.add("my/device/04")
        g2.add("my/device/05")

        g4.add("my/device/08")
        g4.add("my/device/09")

        g3.add("my/device/06")
        g3.add(g4)
        g3.add("my/device/07")

        g1.add("my/device/01")
        g1.add(g2)
        g1.add("my/device/03")
        g1.add(g3)
        g1.add("my/device/02")

    The returned vector content depends on the value of the forward option. If set to true, the results will be organized as follows:

            dl = g1.get_device_list(True)

        dl[0] contains "my/device/01" which belongs to g1
        dl[1] contains "my/device/04" which belongs to g1.g2
        dl[2] contains "my/device/05" which belongs to g1.g2
        dl[3] contains "my/device/03" which belongs to g1
        dl[4] contains "my/device/06" which belongs to g1.g3
        dl[5] contains "my/device/08" which belongs to g1.g3.g4
        dl[6] contains "my/device/09" which belongs to g1.g3.g4
        dl[7] contains "my/device/07" which belongs to g1.g3
        dl[8] contains "my/device/02" which belongs to g1

    If the forward option is set to false, the results are:

            dl = g1.get_device_list(False);

        dl[0] contains "my/device/01" which belongs to g1
        dl[1] contains "my/device/03" which belongs to g1
        dl[2] contains "my/device/02" which belongs to g1

    Parameters:
      forward:

        (`bool`) If it is set to true (the default), the request is forwarded to sub-groups. Otherwise, it is only applied to the local set of devices.

    Return:

      (sequence<`str`>) The list of devices currently in the hierarchy.

    Throws:

  get_fully_qualified_name(self: tango._tango.__Group) → str

    Get the complete (dpt-separated) name of the group. This takes into consideration the name of the group and its parents

  get_name(self: tango._tango.__Group) → str

    Get the name of the group. Eg: Group(‘name’).get_name() == ‘name’

  get_size(self: tango._tango.__Group, forward: bool = True) → int

    get_size (self, forward=True) -> `int`

    Parameters:
      forward:

        (`bool`) If it is set to true (the default), the request is forwarded to sub-groups.

    Return:

      (`int`) The number of the devices in the hierarchy

    Throws:

  is_enabled(self: tango._tango.__Group, device_name: str, forward: bool = True) → bool

    is_enabled (self, device_name, forward) -> `bool`

    Check if a device is enabled

    Parameters:

      - dev_name (str) – device_name name of the element. If more than one device matches the pattern, only the first one will be checked.

      - forward (bool) – flag to perform recursive search for the element in all sub-groups

    New in PyTango 7.0.0

  name_equals(self: tango._tango.__Group, name: str) → bool

    name_equals (name) -> `bool`

    New in PyTango 7.0.0

  name_matches(self: tango._tango.__Group, name: str) → bool

    name_equals(name) -> bool

    New in PyTango 7.0.0

  ping(self: tango._tango.__Group, forward: bool = True) → bool

    ping (self, forward=True) -> `bool`

    Ping all devices in a group.

    Parameters:
      forward:

        (`bool`) If fwd is set to true (the default), the request is also forwarded to subgroups. Otherwise, it is only applied to the local set of devices.

    Return:

      (`bool`) This method returns true if all devices in the group are alive, false otherwise.

    Throws:

  read_attribute(self, attr_name, forward=True) → sequence<GroupAttrReply>
    Just a shortcut to do:

      self.read_attribute_reply(self.read_attribute_asynch(…))

  read_attribute_asynch(self: tango._tango.__Group, attr_name: str, forward: bool = True) → int

    read_attribute_asynch (self, attr_name, forward=True,) -> `int`

    Reads an attribute on each device in the group asynchronously. The method sends the request to all devices and returns immediately.

    Parameters:
      attr_name:

        (`str`) Name of the attribute to read.

      forward:

        (`bool`) If it is set to true (the default) request is forwarded to subgroups. Otherwise, it is only applied to the local set of devices.

    Return:

      (`int`) request id. Pass the returned request id to Group.read_attribute_reply() to obtain the results.

    Throws:

  read_attribute_reply(self: tango._tango.__Group, req_id: SupportsInt, timeout_ms: SupportsInt = 0) → tango._tango.GroupAttrReplyList

    read_attribute_reply (self, req_id, timeout_ms=0 ) -> sequence<`GroupAttrReply`>

    Returns the results of an asynchronous attribute reading.

    Parameters:
      req_id:

        (`int`) a request identifier previously returned by read_attribute_asynch.

      timeout_ms:

        (`int`) For each device in the hierarchy, if the attribute value is not yet available, read_attribute_reply wait timeout_ms milliseconds before throwing an exception. This exception will be part of the global reply. If timeout_ms is set to 0, read_attribute_reply waits “indefinitely”.

    Return:

      (sequence<`GroupAttrReply`>)

    Throws:

  read_attributes(self, attr_names, forward=True) → sequence<GroupAttrReply>
    Just a shortcut to do:

      self.read_attributes_reply(self.read_attributes_asynch(…))

  read_attributes_asynch(self: tango._tango.__Group, attr_names: tango._tango.StdStringVector, forward: bool = True) → int

    read_attributes_asynch (self, attr_names, forward=True) -> `int`

    Reads the attributes on each device in the group asynchronously. The method sends the request to all devices and returns immediately.

    Parameters:
      attr_names:

        (sequence<`str`>) Name of the attributes to read.

      forward:

        (`bool`) If it is set to true (the default) request is forwarded to subgroups. Otherwise, it is only applied to the local set of devices.

    Return:

      (`int`) request id. Pass the returned request id to Group.read_attributes_reply() to obtain the results.

    Throws:

  read_attributes_reply(self: tango._tango.__Group, req_id: SupportsInt, timeout_ms: SupportsInt = 0) → tango._tango.GroupAttrReplyList

    read_attributes_reply (self, req_id, timeout_ms=0 ) -> sequence<`GroupAttrReply`>

    Returns the results of an asynchronous attribute reading.

    Parameters:
      req_id:

        (`int`) a request identifier previously returned by read_attribute_asynch.

      timeout_ms:

        (`int`) For each device in the hierarchy, if the attribute value is not yet available, read_attribute_reply ait timeout_ms milliseconds before throwing an exception. This exception will be part of the global reply. If timeout_ms is set to 0, read_attributes_reply waits “indefinitely”.

    Return:

      (sequence<`GroupAttrReply`>)

    Throws:

  remove(self, patterns, forward=True) → None

    Removes any group or device which name matches the specified pattern.

    The pattern parameter can be a group name, a device name or a device name pattern (e.g domain_*/family/member_*).

    Since we can have groups with the same name in the hierarchy, a group name can be fully qualified to specify which group should be removed. Considering the following group:

    >     -> gauges
    >     | -> cell-01
    >     |     |-> penning
    >     |     |    |-> ...
    >     |     |-> pirani
    >     |          |-> ...
    >     | -> cell-02
    >     |     |-> penning
    >     |     |    |-> ...
    >     |     |-> pirani
    >     |          |-> ...
    >     | -> cell-03
    >     |     |-> ...
    >     |
    >     | -> ...

    A call to gauges->remove(“penning”) will remove any group named “penning” in the hierarchy while gauges->remove(“gauges.cell-02.penning”) will only remove the specified group.

    Parameters:
      patterns:

        (str | sequence<str>) A string with the pattern or a list of patterns.

      forward:

        (`bool`) If fwd is set to true (the default), the remove request is also forwarded to subgroups. Otherwise, it is only applied to the local set of elements. For instance, the following code remove any stepper motor in the hierarchy:

        > root_group->remove(”/stepper_motor/”);

    Return:

      None

    Throws:

  remove_all(self: tango._tango.__Group) → None

    remove_all (self) -> `None`

    Removes all elements in the _RealGroup. After such a call, the _RealGroup is empty.

  set_timeout_millis(self: tango._tango.__Group, timeout_ms: SupportsInt) → None

    set_timeout_millis (self, timeout_ms) -> `bool`

    Set client side timeout for all devices composing the group in milliseconds. Any method which takes longer than this time to execute will throw an exception.

    Parameters:
      timeout_ms:

        (`int`)

    Return:

      None

    Throws:

      (errors are ignored)

    New in PyTango 7.0.0

  write_attribute(self, attr_name, value, forward=True, multi=False) → sequence<GroupReply>
    Just a shortcut to do:

      self.write_attribute_reply(self.write_attribute_asynch(…))

  write_attribute_asynch(self: tango._tango.__Group, attr: object, value: object, forward: bool = True, multi: bool = False) → int

    Writes an attribute on each device in the group asynchronously. The method sends the request to all devices and returns immediately.

    Parameters:
      attr:

        (str | AttributeInfoEx) Name or AttributeInfoEx of the attribute to write.

      value:

        (`any`) Value to write. See DeviceProxy.write_attribute

      forward:

        (`bool`) If it is set to true (the default) request is forwarded to subgroups. Otherwise, it is only applied to the local set of devices.

      multi:

        (`bool`) If it is set to false (the default), the same value is applied to all devices in the group. Otherwise the value is interpreted as a sequence of values, and each value is applied to the corresponding device in the group. In this case len(value) must be equal to group.get_size()!

    Return:

      (`int`) request id. Pass the returned request id to Group.write_attribute_reply() to obtain the acknowledgements.

    Throws:

    Changed in version 10.1.0: attr_name parameter was renamed to attr and added support for `AttributeInfoEx` for attr_values parameter

  write_attribute_reply(self: tango._tango.__Group, req_id: SupportsInt, timeout_ms: SupportsInt = 0) → tango._tango.GroupReplyList

    write_attribute_reply (self, req_id, timeout_ms=0 ) -> sequence<`GroupReply`>

    Returns the acknowledgements of an asynchronous attribute writing.

    Parameters:
      req_id:

        (`int`) a request identifier previously returned by write_attribute_asynch.

      timeout_ms:

        (`int`) For each device in the hierarchy, if the acknowledgment is not yet available, write_attribute_reply wait timeout_ms milliseconds before throwing an exception. This exception will be part of the global reply. If timeout_ms is set to 0, write_attribute_reply waits “indefinitely”.

    Return:

      (sequence<`GroupReply`>)

    Throws:

## GroupReply classes

Group member functions do not return the same as their DeviceProxy counterparts, but objects that contain them. This is:

> - write attribute family returns tango.GroupReplyList

> - read attribute family returns tango.GroupAttrReplyList

> - command inout family returns tango.GroupCmdReplyList

The Group*ReplyList objects are just list-like objects containing `GroupReply`, `GroupAttrReply` and `GroupCmdReply` elements that will be described now.

Note also that GroupReply is the base of GroupCmdReply and GroupAttrReply.

class tango.GroupReply

  This is the base class for the result of an operation on a PyTangoGroup, being it a write attribute, read attribute, or command inout operation.

  It has some trivial common operations:

  > - has_failed(self) -> bool

  > - group_element_enabled(self) ->bool

  > - dev_name(self) -> str

  > - obj_name(self) -> str

  > - get_err_stack(self) -> DevErrorList

  dev_name(self: tango._tango.GroupReply) → str

    dev_name (self) -> `str`

    Returns the device name for the group element

    Returns:

      The device name

    Return type:

      str

  get_err_stack(self: tango._tango.GroupReply) → list[DevError]

    get_err_stack (self) -> `DevErrorList`

    Get error stack

    Returns:

      The error stack

    Return type:

      DevErrorList

  group_element_enabled(self: tango._tango.GroupReply) → bool

    group_element_enabled (self) -> `bool`

    Check if the group element corresponding to this reply is enabled.

    Returns:

      true if corresponding element is enabled, false otherwise

    Return type:

      bool

  has_failed(self: tango._tango.GroupReply) → bool
  obj_name(self: tango._tango.GroupReply) → str

    obj_name (self) -> `str`

    The object name

    Returns:

      The device name

    Return type:

      str

class tango.GroupAttrReply

  Bases: `GroupReply`

  get_data(self: tango._tango.GroupAttrReply, extract_as: tango._tango.ExtractAs = ExtractAs.Numpy) → object

    Get the DeviceAttribute.

    Parameters:
      extract_as:

        (`ExtractAs`)

    Return:

      (`DeviceAttribute`) Whatever is stored there, or None.

class tango.GroupCmdReply

  Bases: `GroupReply`

  get_data(self) → any

    Get the actual value stored in the GroupCmdRply, the command output value. It’s the same as self.get_data_raw().extract()

    Parameters:

      None

    Return:

      (`any`) Whatever is stored there, or None.

  get_data_raw(self: tango._tango.GroupCmdReply) → tango._tango.DeviceData

    get_data_raw (self) -> `any`

    Get the DeviceData containing the output parameter of the command.

    Parameters:

      None

    Return:

      (`DeviceData`) Whatever is stored there, or None.